function [mCnApprox, nChosen, vCn, iV1, iV2 ] = ParsevalApprox( mCn, tolerance )

szMCn = size(mCn);
% Initialize return values
mCnApprox = zeros(szMCn);

% Achieve signal approximation of within tolerance using parsevals theorem
[vCnSorted, iSort] = sort(abs(mCn(:)));

% Calculate cumalative sum of the square of the transform coefficients
vTransformSquared = cumsum(vCnSorted.^2); 

% Get the logical index's of the coefficients we want to keep
indKeep = iSort( vTransformSquared >= tolerance^2 );

% Threshold coefficients
mCnApprox(indKeep) = mCn(indKeep);

% Get a vector containing only retained coefficients
vCn = mCn(indKeep);

% Get indexes of retained coefficients
[iV1, iV2] = ind2sub(szMCn,indKeep);

% Find number of retained coefficinets
nChosen = length(iV1);