function tol = PSNRToBlockErrorNorm( PSNR, nPixelsBlock, maxIntensity )

    % If not specified assume 8 bit intensiy:
    % min 2^0 - 1 = 0 - black
    % max 2^8 - 1 = 255 - white
    if nargin < 3
        
        maxIntensity = 255;
        
    end
    
    pixelErrorSquared = (maxIntensity^2)/(10^(PSNR/10));
    tol = sqrt(pixelErrorSquared*nPixelsBlock);

end