function SaveImage(mImage,saveImagePath,maxIntensity)
% SaveImage Saves a matrix as a lossless JPEG file.
functionName = mfilename;

if nargin < 2
    saveImagePath = 'folded_image.jpg';
end

if nargin < 3     
    bitDepth = ApproxBitdepth(mImage);
else
    bitDepth = log2(maxIntensity+1);
end

% Convert image to the correct format
if bitDepth <= 8
    mUintImage= uint8(mImage);
    bitDepthToWrite = 8;
elseif bitDepth <= 12
    mUintImage = uint16(mImage);
    bitDepthToWrite = 12;
elseif bitDepth <= 16        
    mUintImage = uint16(mImage);
    bitDepthToWrite = 16;
else
    error('%s: Bit depth not compatible with JPEG file format',functionName);
end

% Save as lossless jpeg
imwrite(mUintImage,saveImagePath,'Bitdepth',bitDepthToWrite,'Mode','lossless');